Tutorials
=========

These tutorials are meant to cover various topics on how to use the GNOME
application development platform. They are written for an audience that is
already familiar with the basics of writing programs, and wishes to take
advantage of newer functionality; improve the integration with GNOME; or simply
write more idiomatic code.

Contents
--------

* :doc:`Beginner tutorials </tutorials/beginners>`
* :doc:`Choosing an application ID </tutorials/application-id>`
* :doc:`Using GtkApplication </tutorials/application>`
* :doc:`Saving and restoring window state </tutorials/save-state>`
* :doc:`Using notifications </tutorials/notifications>`
* :doc:`Themed icons </tutorials/themed-icons>`
* :doc:`Dealing with deprecations </tutorials/deprecations>`
* :doc:`Actions </tutorials/actions>` and :doc:`Menus </tutorials/menus>`
* :doc:`Writing a Search Provider </tutorials/search-provider>`
* :doc:`Pre- and Post-Conditions </tutorials/pre-and-post-conditions>`
* :doc:`Main Contexts </tutorials/main-contexts>`
* :doc:`Using Lists </tutorials/lists>`
* :doc:`Threading </tutorials/threading>`
* :doc:`Asynchronous Programming </tutorials/asynchronous-programming>`
* :doc:`Drag and Drop </tutorials/drag-and-drop>`
* :doc:`Widget templates </tutorials/widget-templates>`

.. toctree::
   :maxdepth: 1
   :hidden:

   tutorials/beginners
   tutorials/application-id
   tutorials/application
   tutorials/save-state
   tutorials/notifications
   tutorials/themed-icons
   tutorials/deprecations
   tutorials/actions
   tutorials/menus
   tutorials/search-provider
   tutorials/pre-and-post-conditions
   tutorials/main-contexts
   tutorials/lists
   tutorials/threading
   tutorials/asynchronous-programming
   tutorials/drag-and-drop
   tutorials/widget-templates
